(function( $ ) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */

	$(document).ready(function(){
		// $('[data-toggle="popover"]').popover();
		$('[data-toggle="tooltip"]').tooltip();

		// $(document).find("#ays_pd_default_sorting_points").not('.ays-select-search').select2({
		// 	minimumResultsForSearch: -1
		// });

		// WP color picker start
		var defaultColors = {
			bgColor: "#ffffff",
			mainColor: "#3f72af",
			textColor: "#ffffff",
			buttonsTextColor: "#ffffff",
			titleBoxShadowColor: "rgba(234,234,234,0)",
		};

		var ays_pd_bg_color_picker = {
            defaultColor: defaultColors.bgColor,
			change: function (e) {
                
            }
        };

		var ays_pd_main_color_picker = {
            defaultColor: defaultColors.mainColor,
			change: function (e) {
                
            }
        };

		var ays_pd_text_color_picker = {
            defaultColor: defaultColors.textColor,
			change: function (e) {
                
            }
        };
		
		var ays_pd_buttonsText_color_picker = {
            defaultColor: defaultColors.buttonsTextColor,
			change: function (e) {
                
            }
        };

        var ays_pd_titleBoxShadow_color_picker = {
            defaultColor: defaultColors.titleBoxShadowColor,
			change: function (e) {
                
            }
        };

        var ays_pd_descriptionBoxShadow_color_picker = {
            defaultColor: defaultColors.descriptionBoxShadowColor,
			change: function (e) {
                
            }
        };

        $.fn.goToNormal = function() {
            $('html, body').animate({
                scrollTop: this.offset().top - 200 + 'px'
            }, 'normal');
            return this; // for chaining...
        }

		$(document).find('#ays_pd_bg_color').wpColorPicker(ays_pd_bg_color_picker);
		$(document).find('#ays_pd_main_color').wpColorPicker(ays_pd_main_color_picker);
		$(document).find('#ays_pd_text_color').wpColorPicker(ays_pd_text_color_picker);
		$(document).find('#ays_pd_button_text_color').wpColorPicker(ays_pd_buttonsText_color_picker);
		$(document).find('#ays_pd_title_text_shadow_color').wpColorPicker(ays_pd_titleBoxShadow_color_picker);
		$(document).find('#ays_pd_description_text_shadow_color').wpColorPicker(ays_pd_descriptionBoxShadow_color_picker);
		// WP color picker end


		// Code Mirror
			
		setTimeout(function(){
			if($(document).find('#ays_custom_css').length > 0){
				let CodeEditor = null;
				if(wp.codeEditor){
					CodeEditor = wp.codeEditor.initialize($(document).find('#ays_custom_css'), cm_settings);
				}
				if(CodeEditor !== null){
					CodeEditor.codemirror.on('change', function(e, ev){
						$(CodeEditor.codemirror.display.input.div).find('.CodeMirror-linenumber').remove();
						$(document).find('#ays_custom_css').val(CodeEditor.codemirror.display.input.div.innerText);
							
					});
				}
			

			}
        }, 500);
       
		$(document).find('a[href="#tab2"]').on('click', function (e) {        
            setTimeout(function(){
                if($(document).find('#ays_custom_css').length > 0){
                    var ays_custom_css = $(document).find('#ays_custom_css').html();
                    if(wp.codeEditor){
                        $(document).find('#ays_custom_css').next('.CodeMirror').remove();
                        var CodeEditor = wp.codeEditor.initialize($(document).find('#ays_custom_css'), cm_settings);

                        CodeEditor.codemirror.on('change', function(e, ev){
                            $(CodeEditor.codemirror.display.input.div).find('.CodeMirror-linenumber').remove();
                            $(document).find('#ays_custom_css').val(CodeEditor.codemirror.display.input.div.innerText);
                        });
                        ays_custom_css = CodeEditor.codemirror.getValue();
                        $(document).find('#ays_custom_css').html(ays_custom_css);
                    }
                }
            }, 500);
           
        });

		let toggle_ddmenu = $(document).find('.toggle_ddmenu');
        toggle_ddmenu.on('click', function () {
            let ddmenu = $(this).next();
            let state = ddmenu.attr('data-expanded');
            switch (state) {
                case 'true':
                    $(this).find('.ays_fa_pd').css({
                        transform: 'rotate(0deg)'
                    });
                    ddmenu.attr('data-expanded', 'false');
                    break;
                case 'false':
                    $(this).find('.ays_fa_pd').css({
                        transform: 'rotate(90deg)'
                    });
                    ddmenu.attr('data-expanded', 'true');
                    break;
            }
        });

		$(document).find('input.ays_pd_shortcode').on('mouseleave', function(){
            var _this = $(this);

            _this.attr( 'data-original-title', pdAdminLangObj.clickForCopy );
			_this.tooltip("hide");
        });

		$(document).keydown(function(event) {
            var editButton = $(document).find("input#ays_pd_submit_top");
            if (!(event.which == 83 && event.ctrlKey) && !(event.which == 19)){
                return true;  
            }

            editButton.trigger("click");
            event.preventDefault();
            return false;
        });

		var subButtons = '.button#ays_pd_submit_top';
		$(document).on('click', subButtons ,function () {     
			var $this = $(this);
			submitOnce($this);
		});

		function submitOnce(subButton){
			var subLoader = subButton.siblings(".display_none");
			subLoader.removeClass("display_none");
			subLoader.css("padding-left" , "8px");
			subLoader.css("display" , "inline-block");
			setTimeout(function() {
				$(subButtons).attr('disabled', true);
			}, 50);
			setTimeout(function() {
				$(subButtons).attr('disabled', false);
				subLoader.addClass("display_none");
			}, 5000);
		}

        $('#reset_to_default').on('click', function () {
            setTimeout(function(){
                if($(document).find('#ays_custom_css').length > 0){
                    if(wp.codeEditor){
                        $(document).find('#ays_custom_css').next('.CodeMirror').remove();
                        $(document).find('#ays_custom_css').val('');
                        wp.codeEditor.initialize($(document).find('#ays_custom_css'), cm_settings);
                    }
                }
            }, 100);

            $(document).find("#ays_pd_show_title").prop('checked', true).change();
            $(document).find("#ays_pd_show_description").prop('checked', true).change();

            $(document).find('img.ays-pd-img').attr('src', '').change();
            $(document).find('input#ays_pd_add_logo').val('');
            $(document).find('.ays-pd-image-body').hide().change();
            $(document).find('.ays-pd-logo-url-box').hide().change();
            $(document).find('.ays_pd_logo_position').hide().change();
            $(document).find('.ays-pd-add-image').text('Add Image').show().change();

            $(document).find('#ays_pd_learned_points').val(10);
            $(document).find('#ays_pd_right_points').val(1);
            $(document).find('#ays_pd_wrong_points').val('-0.25');

            $(document).find("#ays_pd_show_correct_answer").prop('checked', false).change();
            $(document).find("#ays_pd_enable_full_screen_mode").prop('checked', false).change();

            $(document).find('#ays_pd_bg_color').val('#ffffff').change();
            $(document).find('#ays_pd_main_color').val('#3f72af').change();
            $(document).find('#ays_pd_text_color').val('#ffffff').change();

            $(document).find("#ays_pd_enable_title_text_shadow").prop('checked', false).change();
            $(document).find('#ays_pd_title_text_shadow_color').val('rgba(234,234,234,0)').change();
            $(document).find('#ays_pd_title_text_shadow_x_offset').val(2);
            $(document).find('#ays_pd_title_text_shadow_y_offset').val(2);
            $(document).find('#ays_pd_title_text_shadow_z_offset').val(2);

            $(document).find('#ays_pd_title_alignment').val('left').change();
            $(document).find('#ays_pd_desc_alignment').val('left').change();

            $(document).find('#ays_pd_description_font_size').val(18);
            $(document).find('#ays_pd_description_font_size_for_mobile').val(18);

            $(document).find("#ays_pd_enable_description_text_shadow").prop('checked', false).change();
            $(document).find('#ays_pd_description_text_shadow_color').val('rgba(234,234,234,0)').change();
            $(document).find('#ays_pd_description_text_shadow_x_offset').val(2);
            $(document).find('#ays_pd_description_text_shadow_y_offset').val(2);
            $(document).find('#ays_pd_description_text_shadow_z_offset').val(2);

            $(document).find('#ays_pd_button_text_color').val('#ffffff').change();

            $(document).find('#ays_pd_buttons_font_size').val(16);
            $(document).find('#ays_pd_buttons_font_size_for_mobile').val(16);

            $(document).find('#ays_pd_buttons_left_right_padding').val(20);
            $(document).find('#ays_pd_buttons_top_bottom_padding').val(10);

            $(document).find('#ays_pd_buttons_border_radius').val(3);
            $(document).find('#ays_pd_container_border_radius').val(0);

            $(document).find('#ays_pd_question_font_size').val(16);
            $(document).find('#ays_pd_question_font_size_for_mobile').val(16);

            $(document).find('#ays_pd_answer_font_size').val(15);
            $(document).find('#ays_pd_answer_font_size_for_mobile').val(15);

            $(document).find('#ays_custom_class').val('');

            $(document).find("#tab1").goToNormal();            
            
        });

		$(document).on('change', '.ays_toggle', function (e) {
            var state = $(this).prop('checked');
            if($(this).hasClass('ays_toggle_slide')){
                switch (state) {
                    case true:
                        $(this).parent().find('.ays_toggle_target').slideDown(250);
                        break;
                    case false:
                        $(this).parent().find('.ays_toggle_target').slideUp(250);
                        break;
                }
            }else{
                switch (state) {
                    case true:
                        $(this).parent().find('.ays_toggle_target').show(250);
                        break;
                    case false:
                        $(this).parent().find('.ays_toggle_target').hide(250);
                        break;
                }
            }
        });

        // Add Image 
        $(document).on('click', '.ays-pd-add-image', function (e) {
            openMediaUploaderForImage(e, $(this));
        });

        // Remove Image
        $(document).on('click', '.removeImage', function (e) {
            var $this = $(this);
            $this.parents('.ays-pd-image-container').find('.ays-pd-image-body').fadeOut(500);
            $this.parents('.ays-pd-image-container').find('.ays-pd-add-image').text( PersonalDictionaryAdmin.addImage );
            setTimeout(function(){
                $(document).find("#ays_pd_logo_enable_image_url").prop("checked" , false);
                $this.parents('.ays-pd-image-container').parent().find('.ays-pd-logo-open-close').hide();
                $this.parents('.ays-pd-image-container').parent().find('.ays-pd-logo-open').hide();
                $this.parents('.ays-pd-image-container').find('.ays-pd-img').removeAttr('src');
                $this.parents('.ays-pd-image-container').find('.ays-pd-img-src').val('');
                $(document).find('.ays-pd-logo-url-box').addClass('display_none');
                $(document).find('.ays_pd_logo_position').addClass('display_none');
            }, 500);
        });
	});
	
})( jQuery );

function selectElementContents(el) {
	if (window.getSelection && document.createRange) {
		var _this = jQuery(document).find('input.ays_pd_shortcode');
		var _thisVal = _this.val();
		
		_this.select();
		document.execCommand('copy');
		
		_this.attr( "data-original-title", pdAdminLangObj.copied );
		_this.attr( "title", pdAdminLangObj.copied );

		_this.tooltip("show");

	} else if (document.selection && document.body.createTextRange) {
		var textRange = document.body.createTextRange();
		textRange.moveToElementText(el);
		textRange.select();
	}
}

function openMediaUploaderForImage(e, element) {
    e.preventDefault();
    var aysUploader = wp.media({
        title: 'Upload',
        button: {
            text: 'Upload'
        },
        library: {
            type: 'image'
        },
        multiple: false
    }).on('select', function () {
        var attachment = aysUploader.state().get('selection').first().toJSON();
        var answerImgCont = element.parents('.ays-pd-image-container').find('.ays-pd-image-body');
        var img = answerImgCont.find('img.ays-pd-img');
        var hiddenInp = answerImgCont.find('input.ays-pd-img-src');

        element.text( PersonalDictionaryAdmin.editImage );
        img.attr('src', attachment.url);
        hiddenInp.val(attachment.url);
        answerImgCont.show();
        img.removeClass('fade');
        jQuery(document).find(".ays-pd-logo-url-box").removeClass("display_none");
        jQuery(document).find(".ays_pd_logo_position").removeClass("display_none");
        var checkImgUrl = jQuery(document).find("#ays_pd_logo_enable_image_url").prop("checked");
        element.parents('.ays-pd-image-container').parent().find('.ays-pd-logo-open').show();
        if(checkImgUrl){
            element.parents('.ays-pd-image-container').parent().find('.ays-pd-logo-open-close').show();
        }
    }).open();
    return false;
}
